class Stack {
    private int[] stack;   // X^bNz
    private int   top=0;   // X^bNgbv(Ƀf[^ꏊ)
    private int   size;

    public Stack (int size) {        // X^bÑRXgN^
        stack = new int[size]; // z𐶐
    	this.size = size;
    }

    public void push (int data) {    // vbV
    	if (top >= size) {
    	    System.err.println("stack overflow"); // WG[o͂֕\
    	} else {
	    stack[top++] = data;
    	}
    }

    public int pop () {              // |bv
    	if (top <= 0) {
    	    System.err.println("stack underflow");
    	    return 0; // _~[
    	} else {
	    return stack[--top];
    	}
    }

    public static void main (String[] args) {
	Stack s1 = new Stack(100); // 傫100̃X^bN쐬
	s1.push(10);               // 10vbV
	s1.push(20);               // 20vbV
	System.out.println(s1.pop()+", "+s1.pop()); // 20, 10

    	Stack s2 = new Stack(1);
    	s2.push(10); s2.push(20);
	System.out.println(s2.pop()+", "+s2.pop()); // 20, 10
    }
}

class Queue {
    private int[] queue;        // L[z
    private int   head=0;       // L[̐擪CfbNX
    private int   tail=0;       // L[̍ŌCfbNX
    private int   size;         // L[̃TCY
    private int   count=0;    	// L[̃f[^

    public Queue (int size) {
        queue = new int[size];    // z𐶐
        this.size = size;
    }

    public void enqueue (int data) {
    	if (count >= size) {
    	    System.err.println("queue overflow");
    	} else {
	    queue[tail] = data;       // L[̍ŌɃf[^i[
	    tail = (tail+1) % size;   // Ō܂ōs玟͐擪
	    count++;
    	}
    }

    public int dequeue () {
    	if (count <= 0) {
    	    System.err.println("queue underflow");
    	    return 0; // _~[
    	} else {
	    int old_head = head;
	    head = (head+1) % size;
	    count--;
	    return queue[old_head];
    	}
    }

    public static void main (String[] args) {
       Queue q1 = new Queue(100);
       q1.enqueue(10);
       q1.enqueue(20);
       System.out.println(q1.dequeue()+", "+q1.dequeue()); //10, 20

       Queue q2 = new Queue(1);
       q2.enqueue(10);
       q2.enqueue(20);
       System.out.println(q2.dequeue()+", "+q2.dequeue()); //10, 20
    }
}

// K4.3.4 ł͋߂ĂȂCq[v̎ȉɎD
class Heap {
    private int[] heap;
    private int   top=0;
    private int   size;
    
    public Heap (int size) {
    	heap = new int[size];
    	this.size = size;
    }

    private int left   (int i) { return 2*i+1; }
    private int right  (int i) { return 2*i+2; }
    private int parent (int i) { return (i-1)/2; }
    private void swap (int i, int j) {
    	int tmp=heap[i]; heap[i]=heap[j]; heap[j]=tmp;
    }

    private void dump () {
    	for (int i=0; i<heap.length; i++) {
    	    System.out.print(heap[i]+" ");
    	}
    	System.out.println();
    }

    public void put (int n) {
    	if (top >= size) {
    	    System.err.println("heap overflow");
    	} else {
	    heap[top++] = n;	
	    for (int i=top-1; i>0 && heap[i]<heap[parent(i)]; i=parent(i)) {
		swap(i, parent(i));
	    }
    	}
    }

    public int get () {
    	if (top <= 0) {
    	    System.err.println("heap underflow");
    	    return 0; // _~[
    	} else {
	    int old_0 = heap[0];
	    heap[0] = heap[--top];
	    for (int i=0, j; left(i)<=top; i=j) {
		// dump();
		j=left(i);
		if (right(i)<top && heap[left(i)]>=heap[right(i)]) {
		    j=right(i);
		}
		if (heap[j]<heap[i]) {
		    swap(i, j);
		} else {
		    break;
		}
	    }
	    return old_0;
    	}
    }

    public static void main (String[] args) {
    	int size=15;
    	Heap heap1 = new Heap(size);
    	int[] data = {5, 4, 8, 2, 13, 12, 14, 1, 3, 7, 6, 9, 10, 11, 0};
    	for (int i=0; i<size; i++) {
    	    heap1.put(data[i]);
    	}
    	heap1.dump();
    	for (int i=0; i<size; i++) {
    	    System.out.print(heap1.get()+" ");
    	}
    	System.out.println();

    	Heap heap2 = new Heap(1);
    	heap2.put(10);
    	heap2.put(20);
	System.out.println(heap2.get());
	System.out.println(heap2.get());
    }
}
